VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.1#0"; "RICHTX32.OCX"
Begin VB.UserControl SyntaxHighlight 
   ClientHeight    =   2475
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4620
   ScaleHeight     =   2475
   ScaleWidth      =   4620
   Begin VB.PictureBox TextboxContainer 
      Height          =   2175
      Left            =   0
      ScaleHeight     =   2115
      ScaleWidth      =   4275
      TabIndex        =   0
      Top             =   0
      Width           =   4335
      Begin RichTextLib.RichTextBox TextBox 
         Height          =   2055
         Left            =   360
         TabIndex        =   1
         Top             =   0
         Width           =   3855
         _ExtentX        =   6800
         _ExtentY        =   3625
         _Version        =   327680
         BorderStyle     =   0
         ScrollBars      =   3
         Appearance      =   0
         TextRTF         =   $"SyntaxHighlight.ctx":0000
         BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
            Name            =   "Courier New"
            Size            =   9.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
      End
   End
End
Attribute VB_Name = "SyntaxHighlight"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'    --------------------------------------------------------------------------
'    ColorSyntax HTML Editor Color Coding Test
'    Copyright (C) 2000  Eric Banker
'
'    This program is free software; you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation; either version 2 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program; if not, write to the Free Software
'    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'    --------------------------------------------------------------------------

'    Some parts of this code were originally developed by Joel Dueck (BlueIce) and
'    David Hoyt(Vhtml)

Option Explicit

' Color coding variables
Private cInTag As Boolean
    
'Default Property Values:
Const m_def_TextCol = 0
Const m_def_TagCol = 0
Const m_def_Enabled = 0

' This is set up by vb by default. I just left it
Public Sub Refresh()

End Sub

' ***************************************************************************************
' These are the textbox functions. IE frontends to the RTB functions
' ***************************************************************************************

' This code here actually colorizes the textbox as the user types

Private Sub TextBox_KeyPress(KeyAscii As Integer)
    ' Bring back the information colored and place in the text box
    KeyAscii = KeyPressEvent(KeyAscii)
End Sub

' These two function are frontends to the rtb load and save
Public Sub OpenFile(strFileName As String)
    ' Open the file
    TextBox.FileName = strFileName
    ' Color code the file
    TextBox.Visible = False
    Colorize
    TextBox.Visible = True
End Sub

Public Sub SaveFile(strFileName As String)
    ' Save the file
    TextBox.SaveFile strFileName
End Sub

Private Sub TextBox_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    ' Set the colors correctly if the user is placeing the cursor somewhere
    ' With the mose
    IsOutsideTag
End Sub

' ***************************************************************************************
' End Textbox Functions
' ***************************************************************************************

' ***************************************************************************************
' These are the color code functions. These handle color coding when the user
' Types, Opens a file, moves the cursor, or inserts a tag
' ***************************************************************************************

' This function Colorizes a file when it is loaded
' --------------------------------------------------------------------------

Private Function Colorize(Optional startchar As Long = 1, Optional endchar As Long = -1)
On Error GoTo ErrHandler

    Dim oldselstart As Long, oldsellen As Long
    
    ' These are place holders for the color coding
    Dim tag_open As Long
    Dim tag_close As Long
    Dim Curr As String
    
    With TextBox
    
    Dim strTextMain As String
    strTextMain = .Text
    
    ' Find out where the cursor is
    oldselstart = .SelStart
    oldsellen = .SelLength
    
    If endchar = -1 Then endchar = Len(strTextMain)
    If startchar = 0 Then startchar = 1

    ' These are the close tags for colorcoding
    tag_close = startchar
    
    ' Now lets loop through the tags and color code it
    Do
        ' See where the next tag starts. if any
        tag_open = InStr(tag_close, strTextMain, "<", vbBinaryCompare)
        
        'If so, then color it...
        If tag_open <> 0 Then  'Found a tag
            
            'Find the end of the next tag...
            tag_close = InStr(tag_open, strTextMain, ">", vbBinaryCompare)

            'Get the current HTML tag...
            Curr = Mid$(strTextMain, tag_open, tag_close - tag_open + 1)
            
            If tag_close <> 0 Then
                ' This colorizes html tags
                If Left$(Curr, 1) = "<" Then
                    tag_close = InStr(tag_open, strTextMain, ">", vbBinaryCompare) + 1
                    .SelStart = tag_open - 1
                    .SelLength = tag_close - tag_open
                    .SelColor = m_TagCol
                End If
            End If
            
            If tag_close = 0 Or tag_close >= endchar Then
                ' If we are coloring tags and it's over the end tag then
                ' get me out of this loop and don't color anymore
                Exit Do
            End If
        Else
            Exit Do
        End If
    Loop
    
    .SelStart = oldselstart
    .SelLength = oldsellen
    .SetFocus
    
    End With
    
    Exit Function
    
ErrHandler:
    Exit Function
End Function

' This is the function that colorizes as the user types
' this function is called by the sub above
' --------------------------------------------------------------

Private Function KeyPressEvent(KeyAscii As Integer) As Integer
    ' Let's create our variables for color coding
    Dim cChar As String

    With TextBox
        ' Bring back the current character
        cChar = Chr$(KeyAscii)
        
        ' If this has already gone through and cintag is not true then
        ' we are not in a tag and colorize as the text color
        If cInTag = False Then
            .SelColor = m_TextCol
        End If

        ' we were not in a tag but the user hit the < which is the
        ' start of a tag so we will color it. but only if cintag = false
        If cChar = "<" And cInTag = False Then
            .SelColor = m_TagCol
            cInTag = True
        End If

        ' If cintag = true and the user typed a > then we need to stop color coding.
        If cChar = ">" And cInTag = True Then
            .SelColor = m_TagCol
            cInTag = False
        End If
    End With

    KeyPressEvent = KeyAscii
End Function

' Insert text w/tag coloring if necessary

Public Sub InsertTag(Tag$)
Dim S As Long
    ' We need to know where the cursor is for color coding
    S = TextBox.SelStart
    
    ' This clears the selected text
    If Len(TextBox.SelText) > 0 Then TextBox.SelText = ""
    
    ' This inserts the tag
    TextBox.SelText = Tag$
    
    ' This colorizes the tag
    Colorize S, S + Len(Tag)
End Sub

' This just tells me where the current cursor is at. Used in the function below
Public Function CurrentCursor() As Long
    CurrentCursor = TextBox.SelStart
End Function

' Move the cursor to the new position in the textbox. I.E. middle of tag

Public Sub PlaceCursor(NewCursor As Long, CurrentCursor As Long)
    TextBox.SelStart = CurrentCursor + NewCursor
    TextBox.SetFocus
End Sub

' This function determines whether the caret is currently outside a tag.
' and color codes correctly

Private Function IsOutsideTag()
On Error Resume Next

' These give me the location of start and
' end tags for all color code items
Dim LastGT As Long, LastLT As Long
Dim EndTag As Long, StartTag As Long

' Here are some text variables
Dim txt$, Start As Long

' These are the variables that tell me where i am at
' and which item to color code
Dim InMainTag As Boolean, InEndTag As Boolean
    
    ' Get back the current text
    txt = TextBox.Text
    Start = TextBox.SelStart
    
    ' This tells me where the last tag is
    EndTag = InStr(Start + 1, txt, ">", vbBinaryCompare)
    StartTag = InStr(Start + 1, txt, "<", vbBinaryCompare)
    
    ' Now compare
    If StartTag > EndTag Then
        InMainTag = True
    Else
        InMainTag = False
    End If
        
    ' This tells me where the next tag is
    LastLT = RevInStr(txt, "<", Start + 1, vbBinaryCompare)
    LastGT = RevInStr(txt, ">", Start + 1, vbBinaryCompare)
        
    ' Now we comapre and see where we are
    If LastLT < LastGT Then
        InEndTag = True
    Else
        InEndTag = False
    End If
    
    ' This code takes the info above and sets the flags right for
    ' color coding
        
    ' This is if Html is true then color code HTML tags
    If InMainTag = True Or InEndTag = True Then
        cInTag = True
        
    ' Nothing is true so don't color code anything
    Else
        cInTag = False
    End If
End Function

' ***************************************************************************************
' End color coding functions
' ***************************************************************************************

' ***************************************************************************************
' This handles the look of the textbox and container as the
' control is resized on the form
' ***************************************************************************************

Private Sub UserControl_Resize()
    ' resize the container to the width of the control
    TextboxContainer.Width = UserControl.Width
    TextboxContainer.Height = UserControl.Height
    
    ' Set the textbox to be the right size in the container
    TextBox.Width = TextboxContainer.Width - 420
    TextBox.Height = TextboxContainer.Height - 60
    
    ' you have to refresh or the scroll bars get all messed up
    TextBox.Refresh
End Sub

' ########################################################################################
' These are for the handling of the saving and loading of control properties             #
' ########################################################################################

Public Property Get Enabled() As Boolean
    Enabled = m_Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
    m_Enabled = New_Enabled
    PropertyChanged "Enabled"
End Property

' Initialize Properties for the color coding stuff
Private Sub UserControl_InitProperties()
    m_Enabled = m_def_Enabled
    
    ' Initialize the Colors
    m_TextCol = m_def_TextCol
    m_TagCol = m_def_TagCol
End Sub

' If there were properties already set then bring them back and keep them
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    m_Enabled = PropBag.ReadProperty("Enabled", m_def_Enabled)

    ' Get Colors
    m_TextCol = PropBag.ReadProperty("TextCol", m_def_TextCol)
    m_TagCol = PropBag.ReadProperty("TagCol", m_def_TagCol)
End Sub

' This writes the properties once they have been selected
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("Enabled", m_Enabled, m_def_Enabled)

    ' Write Colors
    Call PropBag.WriteProperty("TextCol", m_TextCol, m_def_TextCol)
    Call PropBag.WriteProperty("TagCol", m_TagCol, m_def_TagCol)
End Sub

' ------------------------------------------------------------------------
' Get the colors from the control properties. This allows me to bring up
' the color dialog when the user goes to select the color for the text
' or tag
' ------------------------------------------------------------------------

Public Property Get TextCol() As OLE_COLOR
    TextCol = m_TextCol
End Property

Public Property Let TextCol(ByVal New_TextCol As OLE_COLOR)
    m_TextCol = New_TextCol
    PropertyChanged "TextCol"
End Property

Public Property Get TagCol() As OLE_COLOR
    TagCol = m_TagCol
End Property

Public Property Let TagCol(ByVal New_TagCol As OLE_COLOR)
    m_TagCol = New_TagCol
    PropertyChanged "TagCol"
End Property

' ########################################################################################
' End saving and loading code                                                            #
' ########################################################################################
